"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _runtimeDom = require("@vue/runtime-dom");

var _cloneDeep = _interopRequireDefault(require("lodash-es/cloneDeep"));

var _intersection = _interopRequireDefault(require("lodash-es/intersection"));

var _isEqual = _interopRequireDefault(require("lodash-es/isEqual"));

var _validateUtil = require("ant-design-vue/es/form/utils/validateUtil");

var _messages = require("ant-design-vue/es/form/utils/messages");

var _asyncUtil = require("ant-design-vue/es/form/utils/asyncUtil");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? Object(arguments[i]) : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function isRequired(rules) {
  var isRequired = false;

  if (rules && rules.length) {
    rules.every(function (rule) {
      if (rule.required) {
        isRequired = true;
        return false;
      }

      return true;
    });
  }

  return isRequired;
}

function toArray(value) {
  if (value === undefined || value === null) {
    return [];
  }

  return Array.isArray(value) ? value : [value];
}

var isArray = Array.isArray;

var isObject = function isObject(val) {
  return val !== null && typeof val === 'object';
}; // 重置到初始数据，并尽可能的保留响应式


function resetReactiveValue(originValue, refValues) {
  for (var _i = 0, _Object$keys = Object.keys(refValues); _i < _Object$keys.length; _i++) {
    var key = _Object$keys[_i];

    if (!(key in originValue)) {
      delete refValues[key];
    }
  }

  var _loop = function _loop() {
    var _Object$entries$_i = _slicedToArray(_Object$entries[_i2], 2),
        key = _Object$entries$_i[0],
        value = _Object$entries$_i[1];

    var refValue = refValues[key];

    if (isArray(value) && isArray(refValue)) {
      if (value.length <= refValue.length) {
        refValue.splice(value.length, refValue.length - value.length);
      } else {
        refValue.push.apply(refValue, _toConsumableArray(value.slice(refValue.length)));
      }

      value.forEach(function (val, index) {
        refValues[key][index] = resetReactiveValue(val, refValue[index]);
      });
    } else if (isObject(value) && isObject(refValue)) {
      refValues[key] = resetReactiveValue(value, refValue);
    } else {
      refValues[key] = value;
    }
  };

  for (var _i2 = 0, _Object$entries = Object.entries(originValue); _i2 < _Object$entries.length; _i2++) {
    _loop();
  }

  return refValues;
}

function useForm(modelRef, rulesRef, options) {
  var initialModel = (0, _cloneDeep["default"])(modelRef);
  var validateInfos = {};
  Object.keys(initialModel).forEach(function (key) {
    validateInfos[key] = {
      autoLink: false,
      required: isRequired(rulesRef[key])
    };
  });
  validateInfos = (0, _runtimeDom.reactive)(validateInfos);

  var resetFields = function resetFields() {
    // Object.assign(modelRef, initialModel);
    modelRef = resetReactiveValue(initialModel, modelRef);
    (0, _runtimeDom.nextTick)(function () {
      Object.keys(validateInfos).forEach(function (key) {
        validateInfos[key] = {
          autoLink: false,
          required: isRequired(rulesRef[key])
        };
      });
    });
  };

  var filterRules = function filterRules() {
    var rules = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var trigger = arguments.length > 1 ? arguments[1] : undefined;

    if (!trigger.length) {
      return rules;
    } else {
      return rules.filter(function (rule) {
        var triggerList = toArray(rule.trigger || 'change');
        return (0, _intersection["default"])(triggerList, trigger).length;
      });
    }
  };

  var lastValidatePromise = null;

  var validateFields = function validateFields(names, option) {
    var promiseList = [];
    var values = {};
    names.forEach(function (name) {
      var value = modelRef[name];
      values[name] = value;
      var rules = filterRules(rulesRef[name], toArray(option && option.trigger));

      if (rules.length) {
        promiseList.push(validateField(name, value, rules, option || {}).then(function () {
          return {
            name: name,
            errors: []
          };
        })["catch"](function (errors) {
          return Promise.reject({
            name: name,
            errors: errors
          });
        }));
      }
    });
    var summaryPromise = (0, _asyncUtil.allPromiseFinish)(promiseList);
    lastValidatePromise = summaryPromise;
    var returnPromise = summaryPromise.then(function () {
      if (lastValidatePromise === summaryPromise) {
        return Promise.resolve(values);
      }

      return Promise.reject([]);
    })["catch"](function (results) {
      var errorList = results.filter(function (result) {
        return result && result.errors.length;
      });
      return Promise.reject({
        values: values,
        errorFields: errorList,
        outOfDate: lastValidatePromise !== summaryPromise
      });
    }); // Do not throw in console

    returnPromise["catch"](function (e) {
      return e;
    });
    return returnPromise;
  };

  var validateField = function validateField(name, value, rules, option) {
    var promise = (0, _validateUtil.validateRules)([name], value, rules, _objectSpread({
      validateMessages: _messages.defaultValidateMessages
    }, option), !!option.validateFirst);
    validateInfos[name].validateStatus = 'validating';
    promise["catch"](function (e) {
      return e;
    }).then(function () {
      var errors = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (validateInfos[name].validateStatus === 'validating') {
        validateInfos[name].validateStatus = errors.length ? 'error' : 'success';
        validateInfos[name].help = errors[0];
      }
    });
    return promise;
  };

  var validate = function validate(names, option) {
    var keys = [];

    if (!names) {
      keys = Object.keys(modelRef);
    } else if (Array.isArray(names)) {
      keys = names;
    } else {
      keys = [names];
    }

    var promises = validateFields(keys, option); // Do not throw in console

    promises["catch"](function (e) {
      return e;
    });
    return promises;
  };

  var mergeValidateInfo = function mergeValidateInfo() {
    var info = {
      autoLink: false
    };
    var help = [];

    for (var i = 0; i < arguments.length; i++) {
      var arg = i < 0 || arguments.length <= i ? undefined : arguments[i];

      if (arg.validateStatus === 'error') {
        info.validateStatus = 'error';
        arg.help && help.push(arg.help);
      }

      info.required = info.required || arg.required;
    }

    info.help = help.join('\n');
    return info;
  };

  var oldModel = initialModel;
  (0, _runtimeDom.watch)(modelRef, function (model) {
    var names = [];
    Object.keys(model).forEach(function (key) {
      if (!(0, _isEqual["default"])(model[key], oldModel[key])) {
        names.push(key);
      }
    });
    validate(names, {
      trigger: 'change'
    });
    oldModel = (0, _cloneDeep["default"])(model);
  }, {
    immediate: options && !!options.immediate,
    deep: true
  });
  (0, _runtimeDom.watch)(rulesRef, function () {
    if (options && options.validateOnRuleChange) {
      validate();
    }
  }, {
    deep: true
  });
  return {
    modelRef: modelRef,
    rulesRef: rulesRef,
    initialModel: initialModel,
    validateInfos: validateInfos,
    resetFields: resetFields,
    validate: validate,
    validateField: validateField,
    mergeValidateInfo: mergeValidateInfo
  };
}

var _default = useForm;
exports["default"] = _default;